package com.baofoo.Demo;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.baofoo.Entity.Result;
import com.baofoo.SMUtil.SM2;
import com.baofoo.SMUtil.SM4;
import com.baofoo.util.FormatUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;

import net.sf.json.JSONObject;
/**
 * 银行卡验证国密版
 * @author dasheng
 *
 */
public class T_1001_027_01{
	public static void main(String[] args) throws Exception {
		
		String AccNo="6222080302003141092";//银行卡号
		String IdCard="510824198111087470";//身份证
		String IdHolder="罗爱坪";//姓名
		String Mobile="13920999831";//手机号

		String cardtType="101";//卡类型  101:借记卡，102:信用卡
		
		
		/**
		 * 
		 * 取值：123，1234，1234-1
		 * 123：三要素（银行卡号 + 姓名 + 身份证号）
		 * 1234：四要素（银行卡号 + 姓名 + 身份证号 + 银行卡预留手机号）
		 * 1234-1：五要素（银行卡号 + 姓名 + 身份证号 + 银行卡预留手机号+账户类型）
		 */
		String verifyElement="1234";//
		
		String validDate="";//信用卡有效期，如：0117（月+年）(若有值需要加密)
		String validNo="";//信用卡背面3位数字检验码，如：123(若有值需要加密)
		
		String serviceTp="T-1001-027-01";
		String MemberId = "100028462";//商户号
		String TerminalId = "200003586";//终端号
		
		String SignPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_sign_02.sm2";
		String BFSignPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo02.cer";
	    String EncryptPrivatePath = "D:/CER_EN_DECODE/SMEncrypt/test_enc_01.sm2";
	    String BFEncryptPath = "D:/CER_EN_DECODE/SMEncrypt/baofoo01.cer";
	    
	    String signKeyPwd = "123456";
	    String encryptKeyPwd = "123456";
	    
	    String ncrptnSN = "4026170978";
	    String signSN = "1387287848";

	    String SM4Key = FormatUtil.CreateAeskey();//商户自定义(可随机生成  AES key长度为=16位)
		
	    String dgtlEnvlp = SM2.encryptHex(BFEncryptPath, SM4Key);//宝付公钥加密
		Log.Write("SM2公钥加密结果："+ dgtlEnvlp);	
		
		String send_time=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());//报文发送日期时间	
				
		Map<String,String> HeaderMap = new HashMap<String,String>();
		HeaderMap.put("memberId", MemberId);
		HeaderMap.put("terminalId", TerminalId);
		HeaderMap.put("timestamp", send_time);
		HeaderMap.put("version", "1.0");
		HeaderMap.put("charset", "UTF-8");
		HeaderMap.put("verifyType", "10");
		HeaderMap.put("signSN", signSN);
		HeaderMap.put("ncrptnSN", ncrptnSN);
		HeaderMap.put("dgtlEnvlp", dgtlEnvlp);
		
		String tradeDate=new SimpleDateFormat("yyyyMMddHHmmss").format(new Date());
		Map<String,String> BodyMap = new HashMap<String,String>();
		BodyMap.put("trans_id", "TID"+FormatUtil.CreateAeskey(28));
		BodyMap.put("trade_date", tradeDate);
		BodyMap.put("memberId", MemberId);
		BodyMap.put("terminalId", TerminalId);
		BodyMap.put("acc_no", SM4.encryptEcb(SM4Key, AccNo));
		BodyMap.put("id_card", SM4.encryptEcb(SM4Key, IdCard));
		BodyMap.put("id_holder", SM4.encryptEcb(SM4Key, IdHolder));
		BodyMap.put("mobile", SM4.encryptEcb(SM4Key, Mobile));
		BodyMap.put("card_type", cardtType);
		
		if(cardtType.equals("102")) {
			if(!validDate.isEmpty()) {
				BodyMap.put("valid_date", SM4.encryptEcb(SM4Key, validDate));
			}
			if(!validNo.isEmpty()) {
				BodyMap.put("valid_date", SM4.encryptEcb(SM4Key, validNo));
			}
		}
		BodyMap.put("verify_element", verifyElement);
		
		if(verifyElement.equals("1234-1")) {
			BodyMap.put("acc_type", "01");
		}
		
		/**
		BodyMap.put("noticeUrl", "");
		BodyMap.put("settleMode", "");
		BodyMap.put("settleCycle", "");
		BodyMap.put("settleAmtStrategy", "");
		BodyMap.put("calculateAmtValue", "");
		**/

		
		Map<String,String> data_Content = new HashMap<String,String>();
		
		JSONObject Header_Json = JSONObject.fromObject(HeaderMap);
		JSONObject Body_Json = JSONObject.fromObject(BodyMap);
		
		data_Content.put("header", Header_Json.toString());
		data_Content.put("body", Body_Json.toString());
		
		String SignVStr = data_Content.get("header")+data_Content.get("body");	
		Log.Write("拼接串："+SignVStr);
		String Sign = SM2.sign(TerminalId, SignPrivatePath, signKeyPwd, SignVStr);
		Log.Write("SM2签名结果："+Sign);
		data_Content.put("sign", Sign);
		
		String PostString  = HttpUtil.RequestForm("https://vgw.baofoo.com/union-gw/napi/"+serviceTp+"/transReq.do", data_Content);	
		Log.Write("请求返回:"+PostString);
		
		JSONObject ResultJsonObject = JSONObject.fromObject(PostString);
		Result Result_Object = (Result) JSONObject.toBean(ResultJsonObject, Result.class);		
		String RSignStrHB = Result_Object.getHeader()+Result_Object.getBody();		
		Log.Write("返回签名串："+RSignStrHB);

		if(SM2.verify0(TerminalId, BFSignPath, RSignStrHB, Result_Object.getSign())) {
			Log.Write("验签：YES");
		}else {
			Log.Write("验签：NO");
		}
		
		
	}
}